
/*
 Table equatoriale pour XT12
 rayon = 800cm
 axe d'entrainement 21mm
 r=800*2/21=76,19 tours par 24h
 réducteur servomoteur = 280
 76,19x280= 21333 tr/j = 14,81 tr/min

 Un bouton rotatif avec codeur est utilisé pour ajuster la vitesse
 si nécéssaire.

 */

#include <Stepper.h>
#include <Encoder.h>

const int stepsPerRevolution = 8;                           // Le moteur utilisé (un 28byj-48) est en réalité un 32 p/tour avec une réduction de 64
                                                            // le 8 ici utilisé au lieu de 32*64 permet une bien meilleure résolution de la vitesse
                                                            // facteur de correction pour la vitesse 32*64/8=256
const int vitesse = 3793;                                   // N=14,81 tours/min  vitesse= 3793  (14,81*256)   (256*N)
long oldPosition  = -999;                                   
long correction;                                            
int buttonState = 0;

Stepper myStepper(stepsPerRevolution, 9, 11, 10, 8); // cablage du moteur
Encoder myEnc(3, 2);                                        // on utilise 2 entrées avec interruption matérielle (sinon le comptage ne fonctionne pas bien)

void setup() 
{
  pinMode(4, INPUT_PULLUP);
Serial.begin(9600);
Serial.println("Basic Encoder Test:");
}

void loop()
{
  buttonState = digitalRead(4);
  if (buttonState == LOW)                       // si appui sur le bp de l'encodeur on réinitialise la vitesse
  {
    myEnc.write(0);
  }
  myStepper.setSpeed(vitesse+correction);       //N=14,81 tours/min  3793 = 14,81*256   (256*N)
  myStepper.step(-32);                          // 32 pas à la suite (myStepper.step est bloquant)
  long newPosition = myEnc.read();              // on lit la position de l'encodeur
  if (newPosition != oldPosition)
  {
    oldPosition = newPosition;
    correction=newPosition;                   
//    correction=newPosition/4;                   // on ne tient compte que d'un comptage sur 4 pour suivre le crantage (tous les fronts sont comptés)
    Serial.print("correction");Serial.println(correction);
    Serial.print("vitesse+correction");Serial.println(vitesse+correction);
  }
}
